'KONWERTER PLOTER XY na RS232
'do oscyloskopu Tektronix 2224
'z opisami do artykuu EDW
'Autor: Tomasz Sukiennik
'Procesor ATMEGA 8
'portC.2 - wejcie przekanika, styki N.C
'portC.3 - wejcie przekanika, styki N.O.
'portC.0 - wejcie ploter Y
'portC.1 - wejcie ploter X
'$prog &HFF , &HCF , &HD9 , &H00                             'fusy wcz tylko dla wieego procesora, Take care that the chip supports all fuse bytes.
'$sim                                                        'do symulacji w bascom, nie wczaj do kompilacji


$regfile = "m8adef.dat"                                     'Info dla kompilatora.
$crystal = 12000000                                         'Informujemy kompilator o kwarcu 12MHz.

Config Pinb.0 = Output                                      'LED G
Config Pind.7 = Output                                      'LED R
Config Pind.2 = Input                                       'przycisk  1
Config Pind.3 = Input                                       'przycisk  2
Config Pinc.2 = Input                                       ' przekanik, styki N.C.
Config Pinc.3 = Input                                       ' przekanik, styki  N.O.   (przewd biay)

Set Portd.2 : Set Portd.3                                   'rezystory podcigajce do przyciskw
Set Portc.2 : Set Portc.3                                   'rezystory podcigajce do wej przekanikw

Led_r Alias Portd.7 : Led_g Alias Portb.0                   ' aliasy portw
Sw1 Alias Pind.3 : Sw2 Alias Pind.2 : Relay_nc Alias Pinc.2
'kontrola diod LED
Set Led_r                                                   ' led R
Set Led_g                                                   ' led G
Waitms 500
Reset Led_r                                                 'zga led R
Reset Led_g                                                 'zga led G

$baud = 76800                                               'szybko transmisji RS232, pozostae parametry s stae, patrz manual atmega8
Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' konfiguracja przetwornika ADC
Start Adc

Enable Interrupts
'deklaracje zmiennych
Dim Volt0 As Word , Volt1 As Word                           ' zmienne przechowujce wartoci napi odczytane z ADC
Dim Mierz As Bit                                            ' stan mierzenia  jak przekanik ON to mierz=1
Dim Znak As Byte                                            ' zmienna przechowujca znaki wysane z klawiatury na terminalu
Dim Siatka As Bit                                           ' flaga informujca o plotowaniu siatki z oscyloskopu
Dim Linia_nr As Word                                        ' przechowuje kolejny numer plotowanego obiektu z oscyloskopu (ramka, siatka, przebiegi, kursory, opisy itd)

Volt1 = Getadc(0)
Volt0 = Getadc(1)

Print "Konwerter polter XY - RS232"                         ' wywietlenie tekstu startowego na terminalu
Print "do oscyloskopu Tektronix 2224"
Print "klawisz i=instrukcja"

Mierz = 0                                                   'inicjowanie zmiennych
Led_r = 0
Linia_nr = 0
Siatka = 1
'###### Ptla gwna programu #########################################
Do
'If Sw1 = 0 Then                                             'do testw programu
'Toggle Mierz
'Toggle Led_r
'Waitms 500
'End If

If Ischarwaiting() = 1 Then                                 'jeli wcinito jakis klawisz na terminalu
Znak = Inkey()                                              'pobierz znak
Select Case Znak
   Case 105 : Gosub Instrukcja                              ' znak i
   Case 49 : Gosub Siatka0                                  ' znak 1
   Case 50 : Gosub Siatka1                                  ' znak 2
   Case 51 : Gosub Baud1                                    ' znak 3
   Case 52 : Gosub Baud2                                    ' znak 4
   Case 114 : Gosub Resetuj                                 ' znak r
   Case 112 : Gosub Plot                                    ' znak p
   Case 115 : Gosub Stop1                                   ' znak s
End Select
End If

If Mierz = 1 Then

If Relay_nc = 1 Then                                        ' jak pisak opuszczony
   Incr Linia_nr

'pisaki: 1-czarny; 2-niebieski; 3-czerwony; 4-zielony; 5-purpurowy; 6-ty; 7-cyjan; 8-brz
'   If Linia_nr = 2 And Siatka = 0 Then Print "SP3"          'jak narysuje wykres to zmie pisak      /siatka
'   If Linia_nr = 3 And Siatka = 0 Then Print "SP4"          'jak narysuje wykres to zmie pisak
'   If Linia_nr = 4 And Siatka = 0 Then Print "SP5"          'jak narysuje wykres to zmie pisak
'   If Linia_nr = 5 And Siatka = 0 Then Print "SP2"          'jak narysuje wykres to zmie pisak
'   If Linia_nr = 6 And Siatka = 0 Then Print "SP7"          'jak narysuje wykres to zmie pisak
                                                            'siatka jest z 10 obiektw
   If Linia_nr = 11 And Siatka = 1 Then Print "SP2"         'jak narysuje wykres to zmie pisak       /ramka
   If Linia_nr = 12 And Siatka = 1 Then Print "SP3"         'jak narysuje wykres to zmie pisak       /przebieg 1
   If Linia_nr = 13 And Siatka = 1 Then Print "SP4"         'jak narysuje siatk to zmie pisak       /przebieg 2
   If Linia_nr = 14 And Siatka = 1 Then Print "SP6"         'jak narysuje wykres to zmie pisak       /kursor
   If Linia_nr = 15 And Siatka = 1 Then Print "SP5"         'jak narysuje wykres to zmie pisak       /kursor
   If Linia_nr = 16 And Siatka = 1 Then Print "SP7"         'jak narysuje wykres to zmie pisak       /kursor
   If Linia_nr = 16 And Siatka = 1 Then Print "SP4"         'jak narysuje wykres to zmie pisak       /kursor
   If Linia_nr = 16 And Siatka = 1 Then Print "SP8"         'jak narysuje wykres to zmie pisak       /trigger
   If Linia_nr = 16 And Siatka = 1 Then Print "SP6"         'jak narysuje wykres to zmie pisak       /napisy

   Volt0 = Getadc(1)                                        'o X
   Volt1 = Getadc(0)                                        'o Y

   Print "PU" ; Volt0 ; "," ; Volt1 ; ";"                   'wysanie danych
   Print "PD" ; Volt0 ; "," ; Volt1;                        'rednik na kocu bo print bez znaku koca linii
   Kontynuuj:                                               'do prby eliminacji krtkich przerw w przekaniku
   While Relay_nc = 1                                       'dopki pisak opuszczony
       Volt0 = Getadc(1)
       Volt1 = Getadc(0)
      Toggle Led_g
      Print "," ; Volt0 ; "," ; Volt1;
   Wend
   Waitms 3                                                 'prba eliminacji krtkich przerw w przekaniku
   If Relay_nc = 1 Then Goto Kontynuuj                      ' jak wyej
   Print ";"                                                'terminator na koniec linii
   Print "PU" ; ";"                                         'podniesienie pisaka
End If
End If
Loop
End
'================================================
Instrukcja:                                                 'wyswietlanie instrukcji na terminalu
 Print "KONFIG:"
 Print "1-plot bez siatki"
 Print "2-plot z siatka *"
 Print "3-baud=76800 *"
 Print "4-baud=128000"
 Print "* - wartoci domyslne"
 Print "PLOTOWANIE:"
 Print "r-restart"
 Print "p-plot - wysyla naglowek i czeka na dane"
 Print "s-stop - koniec pliku"
Return

Siatka0:                                                    'wyaczenie plotowania z siatk
   Print "siatka nie"
   Siatka = 0
Return

Siatka1:
   Print "siatka tak"                                       'waczenie plotowania z siatk
   Siatka = 1
Return

Resetuj:                                                    'reset zmiennych
   Print "reset"
   Linia_nr = 0
   Mierz = 0
   Led_r = 0
   Led_g = 0
Return

Plot:                                                       ' komendy na pocztek pliku
   Mierz = 1
   Led_r = 1
   Print "IN"
   Print "IP"
   Print "SP1"
Return

Stop1:                                                      'komendy na koniec pliku
   Mierz = 0
   Led_r = 0
   Led_g = 0
   Linia_nr = 0
   Print "PU0,0;"
Return

Baud1:                                                      'zmiana prdkoci przesyu danych
Print "baud=76800"
Baud = 76800
Return

Baud2:                                                      'j.w.
Print "baud=128000"
Baud = 128000
Return